diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPlanksPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPlanksPainted.java
new file mode 100644
index 000000000..af28f603e
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPlanksPainted.java
@@ -0,0 +1,43 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericPlanksPainted<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    static {
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
+            texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks/" + c.colorID);
+        }
+    }
+
+    public final StaticBlockModel[] models = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+
+    public BlockModelGenericPlanksPainted(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
+            this.models[c.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/planks/" + c.colorID).asModel();
+        }
+    }
+
+    public BlockModelGenericPlanksPainted(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
+            this.models[c.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/planks/" + c.colorID).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[data & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPortal.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPortal.java
new file mode 100644
index 000000000..1d8cfc167
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPortal.java
@@ -0,0 +1,37 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicPortal;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericPortal<T extends BlockLogicPortal> extends BlockModelGeneric<T> {
+    public final StaticBlockModel[] models = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericPortal(@NotNull Block<T> block, @NotNull String baseKey) {
+        super(block, BlockModelDispatcher.loadDataModel(baseKey + DyeColor.PURPLE.colorID));
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
+            this.models[c.blockMeta] = BlockModelDispatcher.loadDataModel(baseKey + c.colorID).asModel();
+        }
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int dir = worldSource.getBlockData(tilePos) & 0b1;
+        if (dir > 0) {
+            return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        }
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[this.block.getLogic().fromMetadata(data).blockMeta];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPressurePlate.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPressurePlate.java
new file mode 100644
index 000000000..0414c18b7
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPressurePlate.java
@@ -0,0 +1,44 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicPressurePlate;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericPressurePlate<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel idle;
+    public final @NotNull StaticBlockModel active;
+    public BlockModelGenericPressurePlate(@NotNull Block<T> block, @NotNull String basekey) {
+        super(block, BlockModelDispatcher.loadDataModel(basekey + "/inventory"));
+        this.idle = BlockModelDispatcher.loadDataModel(basekey + "/idle").asModel();
+        this.active = BlockModelDispatcher.loadDataModel(basekey + "/active").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Side direction = BlockLogicPressurePlate.sideFromMeta(worldSource.getBlockData(tilePos));
+        return switch (direction) {
+            case WEST -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 1, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            case EAST -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 3, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            case NORTH -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            case SOUTH -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 2, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            case TOP -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 2, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            default -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+        };
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        int data = source.getBlockData(tilePosc);
+        boolean pressed = (data & BlockLogicPressurePlate.MASK_POWERED) != 0;
+        return pressed ? this.active : this.idle;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPressurePlatePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPressurePlatePainted.java
new file mode 100644
index 000000000..1d0d0b62c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPressurePlatePainted.java
@@ -0,0 +1,40 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicButton;
+import net.minecraft.core.block.BlockLogicPressurePlate;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericPressurePlatePainted<T extends BlockLogic> extends BlockModelGenericPressurePlate<T> {
+    public final @NotNull StaticBlockModel[] inventory = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] idle = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] active = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericPressurePlatePainted(@NotNull Block<T> block) {
+        super(block, "minecraft:block/pressure_plate/planks/white");
+        for (DyeColor color : DyeColor.blockOrderedColors()) {
+            this.inventory[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/pressure_plate/planks/" + color.colorID + "/inventory").asModel();
+            this.idle[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/pressure_plate/planks/" + color.colorID + "/idle").asModel();
+            this.active[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/pressure_plate/planks/" + color.colorID + "/active").asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        int data = source.getBlockData(tilePosc);
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
+        boolean pressed = (data & BlockLogicPressurePlate.MASK_POWERED) != 0;
+        return pressed ? this.active[color] : this.idle[color];
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
+        return this.inventory[color];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRepeater.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRepeater.java
new file mode 100644
index 000000000..3d3ffed79
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRepeater.java
@@ -0,0 +1,32 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicRepeater;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericRepeater<T extends BlockLogicRepeater> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel[] models = new StaticBlockModel[4];
+    public final @NotNull StaticBlockModel[] modelsActive = new StaticBlockModel[4];
+    public BlockModelGenericRepeater(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/repeater/0"));
+        for (int i = 0; i < this.models.length; i++) {
+            this.models[i] = BlockModelDispatcher.loadDataModel("minecraft:block/repeater/" + i).asModel();
+            this.modelsActive[i] = BlockModelDispatcher.loadDataModel("minecraft:block/repeater/active" + i).asModel();
+        }
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int meta = worldSource.getBlockData(tilePos);
+        int direction = meta & BlockLogicRepeater.MASK_DIRECTION;
+        int tick = (meta & BlockLogicRepeater.MASK_TICK_DELAY) >> 2;
+        return (this.block.getLogic().isRepeaterPowered ? this.modelsActive[tick & 0b11] : this.models[tick & 0b11]).renderAttached(this, tessellator, worldSource, tilePos, 0, 4 - direction, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
similarity index 52%
rename from game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
index 12010d5cf..38258c7fd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
@@ -1,26 +1,32 @@
-package net.minecraft.client.render.block.model;
+package net.minecraft.client.render.block.model.generic;
 
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicJarButterfly;
 import net.minecraft.core.block.BlockLogicLanternFirefly;
-import net.minecraft.core.block.BlockLogicRope;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.joml.primitives.AABBd;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
 
-public class BlockModelRope<T extends BlockLogicRope>
-    extends BlockModelStandard<T> {
-    public BlockModelRope(Block<T> block) {
-        super(block);
+public class BlockModelGenericRope<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel line;
+    public final @NotNull StaticBlockModel pile;
+    public BlockModelGenericRope(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/rope/knot"));
+        this.line = BlockModelDispatcher.loadDataModel("minecraft:block/rope/line").asModel();
+        this.pile = BlockModelDispatcher.loadDataModel("minecraft:block/rope/pile").asModel();
     }
 
     @Override
-    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
         Block<?> below = worldSource.getBlock(tilePos.down(new TilePos()));
         boolean hasFloor = below != null && below.canPlaceOnSurface();
         boolean hasBlockNegX = canConnect(worldSource, tilePos, Direction.WEST);
@@ -30,54 +36,40 @@ public class BlockModelRope<T extends BlockLogicRope>
         boolean hasBlockNegZ = canConnect(worldSource, tilePos, Direction.NORTH);
         boolean hasBlockPosZ = canConnect(worldSource, tilePos, Direction.SOUTH);
 
+        boolean didRender = false;
+
 
         boolean drawKnot = !(hasBlockNegX && hasBlockPosX && !hasBlockNegY && !hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
             !(!hasBlockNegX && !hasBlockPosX && hasBlockNegY && hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
             !(!hasBlockNegX && !hasBlockPosX && !hasBlockNegY && !hasBlockPosY && hasBlockNegZ && hasBlockPosZ);
 
-        AABBd bounds = new AABBd(0, 0, 0, 1, 1, 1);
-
-        final float ropeThickness = (1 / 16f);
-        final float knotThickness = (2 / 16f);
-        final float pileWidth = (3 / 16f);
-
-        if (drawKnot) {
-            bounds.setMin(0.5f - knotThickness, 0.5f - knotThickness, 0.5f - knotThickness).setMax(0.5f + knotThickness, 0.5f + knotThickness, 0.5f + knotThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        if (hasBlockNegZ) {
+            didRender |= this.line.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
         }
-
-        if (hasBlockPosY) {
-            bounds.setMin(0.5f - ropeThickness, 0.5f, 0.5f - ropeThickness).setMax(0.5f + ropeThickness, 1, 0.5f + ropeThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        if (hasBlockPosZ) {
+            didRender |= this.line.renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, true, cullFaces, overrideTexture);
         }
-        if (hasBlockNegY) {
-            bounds.setMin(0.5f - ropeThickness, 0, 0.5f - ropeThickness).setMax(0.5f + ropeThickness, 0.5f, 0.5f + ropeThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        if (hasBlockNegX) {
+            didRender |= this.line.renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, true, cullFaces, overrideTexture);
         }
         if (hasBlockPosX) {
-            bounds.setMin(0.5f, 0.5f - ropeThickness, 0.5f - ropeThickness).setMax(1, 0.5f + ropeThickness, 0.5f + ropeThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            didRender |= this.line.renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, true, cullFaces, overrideTexture);
         }
-        if (hasBlockNegX) {
-            bounds.setMin(0, 0.5f - ropeThickness, 0.5f - ropeThickness).setMax(0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        if (hasBlockNegY) {
+            didRender |= this.line.renderAttached(this, tessellator, worldSource, tilePos, 3, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
         }
-        if (hasBlockPosZ) {
-            bounds.setMin(0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f).setMax(0.5f + ropeThickness, 0.5f + ropeThickness, 1);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        if (hasBlockPosY) {
+            didRender |= this.line.renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
         }
-        if (hasBlockNegZ) {
-            bounds.setMin(0.5f - ropeThickness, 0.5f - ropeThickness, 0f).setMax(0.5f + ropeThickness, 0.5f + ropeThickness, 0.5f);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+
+        if (drawKnot) {
+            didRender |= this.staticModel.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
         }
         if (hasFloor) {
-            bounds.setMin(0.5f - pileWidth, 0, 0.5f - pileWidth).setMax(0.5f + pileWidth, knotThickness, 0.5f + pileWidth);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
-            bounds.setMin(0.5f - knotThickness, 0, 0.5f - knotThickness).setMax(0.5f + knotThickness, ropeThickness * 3, 0.5f + knotThickness);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            didRender |= this.pile.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
         }
 
-        return true;
+        return didRender;
     }
 
     private boolean canConnect(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos, @NotNull Direction direction) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRotatable.java
new file mode 100644
index 000000000..8e89fc9a8
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRotatable.java
@@ -0,0 +1,50 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicRotatable;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericRotatable<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelGenericRotatable(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericRotatable(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Direction direction = BlockLogicRotatable.getDirectionFromMeta(worldSource.getBlockData(tilePos));
+        switch (direction) {
+            case UP -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case DOWN -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, -1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case NORTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case WEST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case EAST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case SOUTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericShifted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericShifted.java
new file mode 100644
index 000000000..d1ec5f1a1
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericShifted.java
@@ -0,0 +1,34 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericShifted<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelGenericShifted(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericShifted(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        // Shift grass position with deterministic position based random
+        long dRandom = (tilePos.x() * 0x2fc20fL) ^ (long) tilePos.z() * 0x6ebfff5L ^ (long) tilePos.y();
+        dRandom = dRandom * dRandom * 0x285b825L + dRandom * 11L;
+        double xd = ((double) ((float) (dRandom >> 16 & 15L) / 15F) - 0.5D) * 0.5D;
+        double yd = ((double) ((float) (dRandom >> 20 & 15L) / 15F) - 1.0D) * 0.2D;
+        double zd = ((double) ((float) (dRandom >> 24 & 15L) / 15F) - 0.5D) * 0.5D;
+
+        return this.staticModel.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, xd, yd, zd, false, cullFaces, overrideTexture);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java
new file mode 100644
index 000000000..39393183f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java
@@ -0,0 +1,26 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericSlab<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel upper;
+    public final @NotNull StaticBlockModel full;
+    public BlockModelGenericSlab(@NotNull Block<T> block, @NotNull BlockModelData lower, @NotNull BlockModelData upper, @NotNull BlockModelData full) {
+        super(block, lower);
+        this.upper = upper.asModel();
+        this.full = full.asModel();
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return switch (data & 0b11) {
+            case 1 -> this.full;
+            case 2 -> this.upper;
+            default -> this.staticModel;
+        };
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlabPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlabPainted.java
new file mode 100644
index 000000000..7a7043637
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlabPainted.java
@@ -0,0 +1,35 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericSlabPainted<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel[] upper = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] lower = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] full = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericSlabPainted(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/slab/planks/white/lower"));
+        for (DyeColor color : DyeColor.blockOrderedColors()) {
+            this.upper[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/slab/planks/" + color.colorID + "/upper").asModel();
+            this.lower[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/slab/planks/" + color.colorID + "/lower").asModel();
+            this.full[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/slab/planks/" + color.colorID + "/full").asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
+        return switch (data & 0b11) {
+            case 1 -> this.full[color];
+            case 2 -> this.upper[color];
+            default -> this.lower[color];
+        };
+    }
+}
